VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form frmTipsCOM 
   Caption         =   "frmStandard"
   ClientHeight    =   5295
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7545
   LinkTopic       =   "Form1"
   ScaleHeight     =   5295
   ScaleWidth      =   7545
   StartUpPosition =   3  'Windows-Standard
   Begin MSCommLib.MSComm comFT 
      Left            =   360
      Top             =   360
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.CommandButton cmdEnde 
      Caption         =   "ENDE"
      Height          =   375
      Left            =   5880
      TabIndex        =   1
      Top             =   4200
      Width           =   1335
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "START"
      Height          =   375
      Left            =   5880
      TabIndex        =   0
      Top             =   4680
      Width           =   1335
   End
End
Attribute VB_Name = "frmTipsCOM"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' ------------------------------------------------------------------------------
'
' frmTipsCOM(TipsCOMC.frm)                                Ulrich Mller 12.01.99
'                                                         Procida 400NT    VB6.0
'
' Beispiel fr die Programmierung des seriellen fischertechnik Interfaces 30402
' Nutzung des MS Comm Control (MSCOMM32.OCX)
'
' Es werden hier nur die zum Betrieb unbedingt erforderlichen Befehle
' angegeben, insbesondere fehlen die Fehlerbehandlung und die Bercksichttigung
' der Unterbrechbarkeit
'
' Das Interface mu ca. alle 300 mSek angesprochen werden, sonst schaltet es
' die Motorausgnge ab. Der aktuelle Motorausgang wird in MotorStatus gehalten
'
' Das Interface kennt nur die Befehle
'     wrtInput : Lesen Digitaleingnge
'     wrtEX/EY : Lesen Analogeingnge
' bei beiden erfolgt gleichzeitig ein Refresh des MotorStatus
'
' ------------------------------------------------------------------------------

Option Explicit

Private MotorStatus%              ' --- Status der Motorausgnge
Private wrtInput$, wrtEX$, wrtEY$ ' --- Befehlscodes Write to Interface
Private MotorAus%(1 To 4), MotorLinks%(1 To 4), MotorRechts%(1 To 4)
Private EingabeMaske%(1 To 8)

Private Function CloseInterface() As Integer

' --- Schlieen des COM-Ports ---

  comFT.PortOpen = False             ' --- Schlieen des COM-Ports
  CloseInterface = 0                 ' --- Keine Fehlerbehandlung
  
End Function

Private Function GetAnalog(AnalogNr%) As Integer

' --- Refresh Motorausgnge, Lesen eines Analogeinganges ---

Dim w$

  comFT.Output = IIf(AnalogNr = 0, wrtEX, wrtEY) & Chr$(MotorStatus)
  Do                      ' --- Warten auf Antwort
    w = comFT.Input       '     Byte 1 Inputstatus, Byte 2 & 3 Analog
  Loop Until Len(w) > 0
  GetAnalog = (Asc(Mid(w, 2, 1)) * 256) + Asc(Right(w, 1))

End Function

Private Function GetInput(InputNr%) As Boolean

' --- Lesen eines Digitaleingangs ---

  GetInput = GetInputs() And EingabeMaske(InputNr)
  
End Function

Private Function GetInputs() As Integer

' --- Refresh der Motorausgnge, Abfrage der Digitaleingnge ---

Dim w$

  comFT.Output = wrtInput & Chr$(MotorStatus)  ' Refresh Motorstatus
  Do                                           ' Warten auf Antwort
    w = comFT.Input                            ' Status Digital Eingnge
  Loop Until Len(w) > 0
  GetInputs = Asc(w)
  
End Function

Private Function OpenInterface(PortNr%) As Integer

' --- ffnen des COM-Ports ---
  
  comFT.CommPort = PortNr           ' --- COM-Port-Nummer
  comFT.Settings = "9600,N,8,1"     ' --- Parameter
  comFT.InputLen = 0                ' --- Lesen ganzer Eingabepuffer
  comFT.PortOpen = True             ' --- ffnen des COM-Ports
  MotorStatus = 0
  OpenInterface = 0                 ' --- keine Fehlerbehandlung
  
End Function

Private Function SetMotor(MotorNr%, Richtung%)

' --- Schalten eines Motors ---

' --- MotorStatus auf Motor aus setzen -----
  MotorStatus = MotorStatus And MotorAus(MotorNr)
  Select Case Richtung
  Case 1                       ' --- Motor Linkslauf
    MotorStatus = MotorStatus Or MotorLinks(MotorNr)
  Case 2                       ' --- Motor Rechtslauf
    MotorStatus = MotorStatus Or MotorRechts(MotorNr)
  Case 0                       ' --- Motor aus (schon oben gesetzt)
  Case Else
    MotorStatus = 0
  End Select
  SetMotor = GetInputs()       ' --- Aktualisieren des MotorStatus

End Function

Private Function SetMotors(StatusWord%)

' --- Setzen des MotorStatus im Interface = Schalten aller Motoren ---

  MotorStatus = StatusWord
  SetMotors = GetInputs()

End Function

Private Sub cmdAction_Click()

  OpenInterface 1
  SetMotor 1, 1
  Do
  Loop Until GetInput(1)
  SetMotor 1, 0
  CloseInterface
  
  cmdEnde.SetFocus
  
End Sub


Private Sub cmdEnde_Click()

  End
  
End Sub


Private Sub Form_Load()

' --- Projekt | Eigenschaften | Erstellen | ProductName
  Me.Caption = App.ProductName

  wrtInput = Chr$(193)
  wrtEX = Chr$(197)
  wrtEY = Chr$(201)
    
  MotorAus(1) = &HFFFC
  MotorAus(2) = &HFFF3
  MotorAus(3) = &HFF0F
  MotorAus(4) = &HFF3F
  
  MotorLinks(1) = &H1
  MotorLinks(2) = &H4
  MotorLinks(3) = &H10
  MotorLinks(4) = &H40
  
  MotorRechts(1) = &H2
  MotorRechts(2) = &H8
  MotorRechts(3) = &H20
  MotorRechts(4) = &H80
  
  EingabeMaske(1) = &H1
  EingabeMaske(2) = &H2
  EingabeMaske(3) = &H4
  EingabeMaske(4) = &H8
  EingabeMaske(5) = &H10
  EingabeMaske(6) = &H20
  EingabeMaske(7) = &H30
  EingabeMaske(8) = &H40

End Sub

